"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useFixedDayLabels = void 0;

var _react = require("react");

var _getFixedDayLabels = (dayLabels, weekStartsOn) => {
  if (weekStartsOn > 1) {
    return dayLabels.slice(weekStartsOn).concat(dayLabels.slice(0, weekStartsOn));
  }

  if (weekStartsOn === 1) {
    return dayLabels.slice(1).concat(dayLabels.slice(0, 1));
  }

  return dayLabels;
};

var useFixedDayLabels = (dayLabels, weekStartsOn) => {
  var [fixedDayLabels, setFixedDayLabels] = (0, _react.useState)(_getFixedDayLabels(dayLabels, weekStartsOn));
  (0, _react.useEffect)(() => {
    setFixedDayLabels(_getFixedDayLabels(dayLabels, weekStartsOn));
  }, [dayLabels, weekStartsOn]);
  return fixedDayLabels;
};

exports.useFixedDayLabels = useFixedDayLabels;